	
;=====<< COPYRIGHT >>===\
; 
;     "ATC" oop for asm   VERSION 31
; C++ and COM compatible
; Author: Ilian Dinev [Ultrano]
; ultrano@ultrano.com  
; best viewed with my XASM 
; COM support added thanks to EvilHomer2k
;=======/
	
	
;=====<< SWITCHES >>===\
;-------[ OOP switches !!!! ]--------------------------------------------------------------\
ifndef enlist_procs 
	;----------\
	enlist_procs = 0  	; 1 = automatically generate procedures to ECHO, XASM shows it best. 	
	;----------/		; Will produce symbol redefinition, that you have to clear yourself 
				; (when you use inheritage)
endif
ifndef DisplayClassHardcode
	DisplayClassHardcode 	= 0  ; whether to write hard.code to xasm output.
endif
ifndef FirstParameterIsMe
	FirstParameterIsMe	= 1  ; all functions will be like CObject_doit proc me,var1,var2 ; otherwise "me" is skipped
endif
ifndef PreserveClassECX
	PreserveClassECX	= 1
endif
		
	;------[ ADVANCED OPTIONS ]---------------------------------\
	; not for newbies with the ATC!
	
ifndef DisplayClassHardMembers
	DisplayClassHardMembers	= 0	; - the twin-bro of DisplayClassHardcode
endif
ifndef DisplayClassHard_bind
	DisplayClassHard_bind	= 1	; - splits the normal hardcode output (the two twin-bros above),
					;   only for better readability
endif
ifndef AdjustClassStack
	AdjustClassStack	= 0	; - define if you want auto adjustment, a rare thing to do.
endif
ifndef SpeedyClass
	SpeedyClass 		= 0	; - if you want to compile the hardcoded stuff instead		
endif
	DefaultClassName textequ <> 	; - no need to touch
	
;------------------------------------------------------------------------------------------/
;=======/
;=====<< INIT SOME GLOBAL VARS >>===\
@current_class textequ <>
@parent_class textequ <>
if DisplayClassHard_bind AND DisplayClassHardcode
		DisplayClassHardMembers = 1
endif
	
if enlist_procs eq 1
	.err <[--------- End of list of procedures -------]>
endif	
	
if DisplayClassHardcode
	.err <---------- End of list of structure defs -->
endif
	
if DisplayClassHardMembers
	.err <---------- End of list of class members -->
endif
	
;=======/
	
;=====<< END CLASS >>===\
endclass MACRO
	local baka,cName,baka2,tab,baka3,baka4,Parent,ParentNew,Constructor,ParentDelete,Destructor
	local DisplayedFunc,desen,foundDele,opAsaTtrib,ConstructorArgs,ParentArgs,ThisFuncName,tempInt1
	
	;-----[ Init check and variables ]-----------\
	if SpeedyClass
	  exitm
	endif
	baka CATSTR @current_class,< ends>
	baka
	if DisplayClassHardcode
		%echo baka
	endif
	cName textequ <@current_class>
	ConstructorArgs CATSTR cName,<_$NewArgs>
	@global_virtuals_num = 0
	@global_done_virtuals = 0
	@global_actions_num = 0
	@global_done_actions = 0
	;--------------------------------------------/
	
	;----[ See what the functions will be ]------------------------------------------------\
	@enlist_class_virtuals cName  ; start building structure and register virtual functions
	@enlist_class_actions cName 
	;--------------------------------------------------------------------------------------/
	
	;----[ Start a virtual table ]--------------\
	baka CATSTR @current_class,<_$virt_table>
	baka:
	if DisplayClassHardcode
		echo 
		%echo baka:
	endif
	;-------------------------------------------/
	
	if enlist_procs	;-------------------[ Enlist constructor and destructor ]----\
		if FirstParameterIsMe2
			ifnb ConstructorArgs
			%echo @current_class&_&@current_class proc me,ConstructorArgs
			else
			%echo @current_class&_&@current_class proc me
			endif
		else
			%echo @current_class&_&@current_class proc ConstructorArgs
		endif
		echo      ret
		%echo @current_class&_&@current_class endp	
		echo 
		
		%echo @current_class&_$&@current_class proc 
		echo      ret
		%echo @current_class&_$&@current_class endp	
		echo 
	endif
	;----------------------------------------------------------------------------/
	
	;------------[ Build the virtual table ]----------------------------------------\
	baka2=0
   while baka2 LT @global_done_virtuals
	
	baka 		textequ @CatStr(<@built_f2_>,%baka2)
	ThisFuncName 	textequ @CatStr(<@built_f_>,%baka2)
	ThisFuncName CATSTR @current_class,<_>,ThisFuncName
	
	tempInt1 = 0
	if @ThisClassIsCOM_Compatible
		tempInt1 = -1
	endif
	if enlist_procs AND (baka2 ne tempInt1)
		baka4 CATSTR baka,<$d>		; Enlist Procs --------\
		%echo baka proc baka4		;			|
	  	echo ret			;         ^_^		|     ENLIST PROCS
		%echo baka endp			;			|
		echo 				;----------------------/
	else
		baka4 textequ @CatStr(<@built_f_>,%baka2)	
		baka4 CATSTR @current_class,<_>,baka4
		
		if HostedClass  ; if normal, then ;------------------------\
		 dd baka   	; register in table			   |  TABLE REGISTERING
		endif ;----------------------------------------------------/
		;--------------[ Display hardcode data ]--------------\
		if DisplayClassHardcode
			%echo dd baka
		endif
		if DisplayClassHardMembers
			%echo baka4&&$r textequ <baka>
			%echo baka4&&$isV = 1
		endif
		;----------------------------------------------\
		baka textequ @CatStr(<@built_f_>,%baka2)	;
		baka CATSTR @current_class,<_>,baka,<$>		;	REGISTER VIRTUAL FOR iCall
		baka = baka2					;
		;----------------------------------------------/
		if DisplayClassHardMembers
			DisplayedFunc CATSTR baka,< equ >,%baka2
			%echo DisplayedFunc
		endif
		;----------------------------------------------------/
	endif
	baka2=baka2+1
   endm
	;-------------------------------------------------------------------------------/
	
	
	;------------[ Enlist class Actions ]-----------\
	baka2=0
   while baka2 LT @global_done_actions
	baka 		textequ @CatStr(<@built_fa2_>,%baka2)
	baka4 CATSTR baka,<$d>		
	if enlist_procs				; Enlist Procs --------\
		%echo baka proc baka4		;			|
		echo ret			;         ^_^		|     ENLIST PROCS iActions
		%echo baka endp			;			|
		echo 				;----------------------/
	endif
	baka4 textequ @CatStr(<@built_fa_>,%baka2)	
	baka4 CATSTR @current_class,<_>,baka4
	if DisplayClassHardMembers
		%echo baka4&&$r textequ <baka>
		%echo baka4&&$isV = 0
	endif
	baka2=baka2+1
   endm
	
	;-----------------------------------------------/
	
	
	
	ife HostedClass ;---[ exit if no more business ]--\
		@current_class textequ <>
		exitm
	endif ;-------------------------------------------/
	
	
	;--------[ static stuff ]-------\
	if @statics_num ne 0
	.data
	if DisplayClassHardcode
	  echo .data
	endif
	baka2 = 0
	while baka2 LT @statics_num
	baka4 CATSTR <@statics>,%baka2
	baka4 CATSTR cName,<_>,baka4
	if DisplayClassHardcode
		%echo baka4
	endif
	baka4
	baka2 = baka2 + 1
	endm
	if DisplayClassHardcode
	  echo .code
	endif
	.code
	endif
	;-------------------------------/
	
	;----< create real constructor >-------------------------------------------------\
	
	baka CATSTR @current_class,<___>,@current_class
	Parent CATSTR @current_class,<_$Parent>
	ParentNew CATSTR Parent,<___>,Parent
	ParentDelete CATSTR Parent,<___$delete>
	Constructor CATSTR @current_class,<_>,@current_class
	Destructor CATSTR @current_class,<_$>,@current_class
	ParentArgs CATSTR @current_class,<_$ParentArgs>
	
		
  baka proc ConstructorArgs	; Object___Object    +args
	.if !ecx
		mov ecx,malloc(sizeof cName)
		mov dword ptr[ecx],offset @CatStr(%cName,<_$virt_table>)
	.endif
	ifdif Parent,<>
	 push ecx
		ifnb ParentArgs
		  invoke ParentNew,ParentArgs
		else 
		  invoke ParentNew
		endif
	 pop ecx
	endif
	
	push ecx
	ifdif ConstructorArgs,<>
	   if FirstParameterIsMe2
	     invoke Constructor,ecx,ConstructorArgs
	   else
	     invoke Constructor,ConstructorArgs
	   endif
	else
	   if FirstParameterIsMe2
	     push ecx
	     call Constructor
	   else
	     call Constructor
	   endif
	endif
	pop ecx
	mov eax,ecx
	ret
  baka endp
	
if DisplayClassHardcode	
	
	
	
	%echo cName&&_$ParentArgs textequ <ParentArgs>
	%echo cName&&_$NewArgs textequ <ConstructorArgs>
	baka2 = @CatStr(%cName,<_$cpp>)
	baka4 CATSTR %baka2
	%echo cName&&_$cpp = baka4
	baka2 = @CatStr(%cName,<_$IsCOM>)
	baka4 CATSTR %baka2
	%echo cName&&_$IsCOM = baka4
	echo 
	
	
	
	echo
 %echo baka proc ConstructorArgs
	echo .if !ecx
	echo malloc_func proto :DWORD
	%echo invoke malloc_func,sizeof cName
	echo	mov ecx,eax
	%echo	mov dword ptr[ecx],offset @CatStr(%cName,<_$virt_table>)
	echo.endif

	ifdif Parent,<>
	  echo push ecx
	  %echo call ParentNew
	  echo pop ecx
	endif
	
	echo push ecx
	ifnb ConstructorArgs
	   if FirstParameterIsMe2
	     %echo invoke Constructor,ecx,ConstructorArgs
	   else
	     %echo invoke Constructor,ConstructorArgs
	   endif
	else
	   if FirstParameterIsMe2
	     echo push ecx
	    %echo call Constructor
	   else
	     %echo call Constructor
	   endif
	endif
	echo pop ecx
	echo mov eax,ecx
	echo ret
 %echo baka endp
	
endif
	;----------------------------------------------------------------------------/
	
	
	;-------< Create real destructor >-------------------------------------------------------\
  baka CATSTR @current_class,<___$delete>
	
	
	
  baka proc exitcode  ; Object___$Object
	push ecx
	    if FirstParameterIsMe2
	        push ecx
	    endif
	    call Destructor
	pop ecx
	
	ifdif Parent,<>
	 push ecx
	 invoke ParentDelete,exitcode
	 pop ecx
	else
	 free ecx
	endif
	
	ret
  baka endp	
	
if DisplayClassHardcode	
	%echo baka proc exitcode
	echo push ecx
	if FirstParameterIsMe2
	 echo push ecx
	endif 
	%echo call Destructor
	echo pop ecx
	
	ifdif Parent,<>
	echo push ecx
	%echo invoke ParentDelete,exitcode
	echo pop ecx
	else
	echo free ecx
	endif
	
	echo ret
  %echo baka endp	
endif	
	
	
	;----------------------------------------------------------------------------------------/
	
		
	
	
	
	
	@current_class textequ <>
endm	
;=======/
;=====<< DEFINE DATA IN CLASS >>===\
AddClassData MACRO vName
	local cName,cvn,cvt
	
	if SpeedyClass
	  exitm
	endif
	
	
	cName textequ <@current_class>
	cvt CATSTR cName,<_$vn>
	cvn equ cvt ; number of variables, already existing
	cvt CATSTR cName,<_$vn_>
	cvt CATSTR cvt,%cvn
	@CatStr(cvt,< textequ <&vName>>)
	cvt CATSTR cName,<_$vn>
	cvt = cvt +1
	vName
	if DisplayClassHardcode
	 %echo vName
	endif
endm
	float MACRO var1
		AddClassData <var1 real4 ?>
	endm
	double MACRO var1
		AddClassData <var1 real8 ?>
	endm
	long MACRO var1
		AddClassData <var1 dd ?>
	endm
	char MACRO var1
		AddClassData <var1 db ?>
	endm
	short_int MACRO var1
		AddClassData <var1 dw ?>
	endm
	des MACRO var1
		AddClassData <var1 !<!>>
	endm
	
	dea MACRO dataName
		AddClassData <dataName dup!(!<!>!)> 
	endm

            Vec MACRO var1
                        AddClassData <var1 D3DVECTOR3 <?>>
            endm
            _plane MACRO var1
                        AddClassData <var1 D3DXPLANE <?>>
            endm

            Mat MACRO var1
                        AddClassData <var1 D3DXMATRIX <?>>
            endm


	array macro argName:REQ, argType:REQ, argNum:REQ
                	AddClassData <argName argType argNum dup (<?>)>
	endm

	
;=======/
;=====<< CLASS >>===\
class MACRO cName:REQ,ParentClass,CPP_compatible
	local baka
	;----[ precautions ]-----\
	ifndef HostedClass
		HostedClass=1
	endif
	ifndef SpeedyClass
		SpeedyClass=0
	endif
	.code
	if SpeedyClass
		exitm 
	endif
	;------------------------/
	
	;--< check for errors >------------------------------\
	ifdef cName&_$IsDefined
		.err <The class "&cName" is already defined!!>
	endif
	ifdef @current_class
	ifdif @current_class,<>
		.err <Do not create the class "&cName" before you finish defining the other class!!>
	endif
	endif
	ifdif <ParentClass>,<>
	ifndef ParentClass&_$Parent 
		.err <The class "&ParentClass" does not exist, though wanted by class "&cName">
	endif
	endif
	;----------------------------------------------------/
	
	;---[ set up global variables ]---------\
	@current_class textequ <cName>
	@parent_class  textequ <ParentClass>
	@statics_num  	= 0
	
	@CatStr(cName, <_$IsDefined>) = 1	; register class
	@CatStr(cName, <_$afn>) = 0		; action  functions num
	@CatStr(cName, <_$vfn>) = 0		; virtual functions num
	@CatStr(cName, <_$vn>)  = 0		; variables num
	
	@CatStr(cName, <_$Parent>) 	textequ <ParentClass>
	@CatStr(cName, <_$NewArgs>) 	textequ <>
	@CatStr(cName, <_$ParentArgs>) 	textequ <>
	;---------------------------------------/
	
	;-----[ Compatibility with C++ ]--------\
	@CatStr(cName, <_$cpp>) 	= 0
	FirstParameterIsMe2 		= 1
	ifnb <CPP_compatible>
		@CatStr(cName, <_$cpp>) = 1
		FirstParameterIsMe2 	= 0
	endif
	if FirstParameterIsMe eq 0
		@CatStr(cName, <_$cpp>) = 1
		FirstParameterIsMe2	= 0
	endif
	;---------------------------------------/
	
	;-----[ Compatibility with COM ]-------------\
	@CatStr(cName, <_$IsCOM>)  		= 0
	@ThisClassIsCOM_Compatible		= 0
	ifidni <CPP_compatible>,<COM compatible>
		@CatStr(cName, <_$IsCOM>)  	= 1
		@ThisClassIsCOM_Compatible	= 1
		@CatStr(cName, <_$cpp>) 	= 0
		FirstParameterIsMe2 		= 1
	endif
	;--------------------------------------------/
	
	;---[ start up struct ]-------------------------------\
	if DisplayClassHardcode
	   echo 
	   %echo cName struct
	endif
	
cName struct	; Start the structure
	
	ifidn <ParentClass>,<>
		long $virtual_table  ; virtual table ptr
	else
		@enlist_class_variables <ParentClass>
	endif
	;-----------------------------------------------------/
	
	ife @ThisClassIsCOM_Compatible
		virtual __$delete
	endif
	
endm
;=======/
;=====<< STRIP ARGUMENTS >>===\
StripArguments macro var1:VARARG
	local char1,txt
	txt textequ <>
	forc char1,<var1>
	 ifidn <char1>,< >
	 elseifidn <char1>,<	>
	 else
	 txt CATSTR txt,<char1>
	 endif
	endm
	exitm <txt>
endm
;=======/
;=====<< VIRTUAL STATEMENT >>===\
virtual MACRO var1:VARARG
	local cName,cvfn,cvft,cvft2,fName,var2,baka2
	local desen,right_start,argsNum,RRS,RRS2,ParameterCheck,baka,ConstructorArgs,ParentArgs
	
	;---[ Initial checks ]-----------------\
	if SpeedyClass
		exitm
	endif
	cName textequ <@current_class>	
	; ignore old-style declaration of virtual destructor. 	
	ifidn <$>, @SubStr(<var1>,1,1) 
		exitm
	endif
	var2 textequ StripArguments(<var1>)
	ParameterCheck=0
	;-------------------------------------/
	
	if @InStr(1,%var2,<:>) ;-------------------------\
		ParameterCheck = 1
		right_start = @InStr(1,%var2,<:>)
		if @SizeStr(%var2) eq right_start
			desen textequ <>
		else
			desen SUBSTR var2,right_start+1
		endif
		
		; now count the vars num
		
		argsNum=0
		%for arg,<desen>
		  argsNum = argsNum + 1
		endm
		;.err %argsNum
		;.err desen
		RRS= @InStr(1,%var2,<:>) 
		fName SUBSTR var2,1,RRS-1
		
	else
		fName textequ <var2>
		desen textequ <>
		argsNum = 1000
	endif ;------------------------------------------/	
	
	ife @CatStr(%cName,<_$cpp>) ;------------\
		ifdif desen,<>
			desen CATSTR <me,>,desen
		else
			desen CATSTR <me>
		endif
	endif ;---------------------------------/
	
	;---------[ setup texts and constants ]-------------------------------------\
	cvfn = @CatStr(%cName,<_$vfn>)	; number of virtual funcs, already existing
	@CatStr(%cName,<_$fn_>,%cvfn) textequ <&fName>
	@CatStr(%cName,<_>,%fName,<$d>) textequ <&desen>
	@CatStr(%cName,<_>,%fName,<$argz>) = argsNum
	@CatStr(%cName,<_>,%fName,<$isV>)  = 1 ; It is virtual
	
	if DisplayClassHardMembers
		cvft CATSTR %argsNum
		baka CATSTR cName,<_>,fName,<$argz = >,cvft
		%echo baka
	endif
	
	cvft CATSTR cName,<_$vfn>
	cvft = cvft +1
	;---------------------------------------------------------------------------/
endm
;=======/
;=====<< iAction STATEMENT >>===\
iAction MACRO var1:VARARG
	local cName,avfn,avft,cvft2,fName,var2,baka2
	local desen,right_start,argsNum,RRS,RRS2,ParameterCheck,baka,ConstructorArgs,ParentArgs
	
	;---[ Initial checks ]-----------------\
	if SpeedyClass
		exitm
	endif
	cName textequ <@current_class>	
	; ignore old-style declaration of virtual destructor. 	
	ifidn <$>, @SubStr(<var1>,1,1) 
		exitm
	endif
	var2 textequ StripArguments(<var1>)
	ParameterCheck=0
	;-------------------------------------/
	
	if @InStr(1,%var2,<:>) ;-------------------------\
		ParameterCheck = 1
		right_start = @InStr(1,%var2,<:>)
		if @SizeStr(%var2) eq right_start
			desen textequ <>
		else
			desen SUBSTR var2,right_start+1
		endif
		argsNum=0
		%for arg,<desen>
		  argsNum = argsNum + 1
		endm
		RRS= @InStr(1,%var2,<:>) 
		fName SUBSTR var2,1,RRS-1
	else
		fName textequ <var2>
		desen textequ <>
		argsNum = 1000
	endif ;------------------------------------------/	
	
	;-------------------[ constructor modifier ]--------------------------\
	ifidn cName,fName
		cvfn INSTR desen,<:>
		if cvfn
			ConstructorArgs SUBSTR desen,1,cvfn-1
			ParentArgs SUBSTR desen,cvfn+1		
			@CatStr(%cName,<_$ParentArgs>) textequ <&ParentArgs>
			@CatStr(%cName,<_$NewArgs>) textequ <&ConstructorArgs>
		else
			ConstructorArgs SUBSTR desen,1
			ParentArgs textequ <>
			@CatStr(%cName,<_$NewArgs>) textequ <&desen>
		endif	
		exitm
	endif ;---------------------------------------------------------------/
	
	ife @CatStr(%cName,<_$cpp>) ;------------\
		ifdif desen,<>
			desen CATSTR <me,>,desen
		else
			desen CATSTR <me>
		endif
	endif ;---------------------------------/
	
	
	;---------[ setup texts and constants ]-------------------------------------\
	avfn = @CatStr(%cName,<_$afn>)	; number of virtual funcs, already existing
	@CatStr(%cName,<_$an_>,%avfn) textequ <&fName>
	@CatStr(%cName,<_>,%fName,<$d>) textequ <&desen>
	@CatStr(%cName,<_>,%fName,<$argz>) = argsNum
	@CatStr(%cName,<_>,%fName,<$isV>)  = 0 ; It is NOT virtual
	
	
	if DisplayClassHardMembers
		avft CATSTR %argsNum
		baka CATSTR cName,<_>,fName,<$argz = >,avft
		%echo baka
	endif
	
	avft CATSTR cName,<_$afn>
	avft = avft +1
	;---------------------------------------------------------------------------/
	
	
endm
;=======/
;=====<< ENLIST CLASS VARS >>===\
@enlist_class_variables MACRO cName
	local ParentClass,baka,cvfn,cvft,cvft2,tName,cName2
	cName2 textequ <cName>
	ParentClass CATSTR cName2,<_$Parent>
	ifdif ParentClass,<>
		@enlist_class_variables <&ParentClass>
	endif
	;---< enlist variables >------------------------------------\
	cvft CATSTR cName2,<_$vn>
	cvfn equ cvft
	baka=0
    while baka LT cvfn ; for each variable in this class ...
	cvft CATSTR cName2,<_$vn_>
	cvft2 CATSTR cvft,%baka
	cvft2
	if DisplayClassHardcode
		%echo cvft2
	endif
	baka=baka+1
    endm
	;-----------------------------------------------------------/
endm
;=======/
;=====<< ADD VIRTUAL FUNC (REAL) >>===\
@AddVirtualFunction macro cName,cFunc
	local already_exists,bakale,ft,ft2,cFunc2,cFunc3,baka2kun,baka3,gClass,bakame,curCla,baka
	local sami,curClass,baka2
	sami textequ <$r>
	curClass textequ <@current_class>
	
	;---< check if virtual function has been already defined >---\
	already_exists = 0
	bakale = 0	
	cFunc2 textequ <cFunc>
    while bakale LT @global_done_virtuals
	cFunc3 CATSTR <@built_f_>,%bakale
	ifidn cFunc2,cFunc3
	  already_exists = bakale+1
	endif
    bakale = bakale + 1
    endm
	
	;------------------------------------------------------------/
	
	
	
	if already_exists eq 0
		@CatStr(<@built_f_>,%@global_done_virtuals) textequ cFunc
		@CatStr(<@built_f2_>,%@global_done_virtuals) CATSTR cName,<_>,cFunc
		@global_done_virtuals = @global_done_virtuals + 1
	else
	 @CatStr(<@built_f2_>,%(already_exists-1)) CATSTR cName,<_>,cFunc
	endif
	
	ifdifi cFunc,<__$delete>
		bakame CATSTR <_>, cFunc, <$r>  ;  CATSTR curClass,<_>,cFunc,<$r>
		baka CATSTR cName,<_>,cFunc
		@CatStr(%curClass,%bakame) textequ <&baka>
	endif
	
endm	
;=======/
;=====<< ENLIST CLASS VIRTUALS >>===\
@enlist_class_virtuals MACRO cName
	local ParentClass,baka,cvfn,cvft,tName
	local baka2,already_exists,fn,ft,ft2
	ParentClass CATSTR cName,<_$Parent>
	
	ifdif ParentClass,<>
		@enlist_class_virtuals &ParentClass
	endif
	
	
	
	;-------< enlist virtuals >----------------------------------------\
	cvft CATSTR cName,<_$vfn>
	cvfn equ cvft
	baka=0
    while baka LT cvfn ; for each virtual function in this class ...
	cvft CATSTR cName,<_$fn_>
	cvft CATSTR cvft,%baka
	
	;--< ADD VIRTUAL FUNCTION !>------------\*********************************************************
	; cName - cur class
	; cvft  - func name
	@AddVirtualFunction cName,cvft
	
	;---------------------------------------/*********************************************************
	
	@global_virtuals_num=@global_virtuals_num +1
	baka=baka+1
    endm
	;------------------------------------------------------------------/
	
endm
;=======/
;=====<< ADD ACTION FUNC (REAL) >>===\
@AddActionFunction macro cName,cFunc
	local already_exists,bakale,ft,ft2,cFunc2,cFunc3,baka2kun,baka3,gClass,bakame,curCla,baka
	local sami,curClass,baka2
	sami textequ <$r>
	curClass textequ <@current_class>
	
	;---< check if virtual function has been already defined >---\
	already_exists = 0
	bakale = 0	
	cFunc2 textequ <cFunc>
    while bakale LT @global_done_virtuals
	cFunc3 CATSTR <@built_fa_>,%bakale
	ifidn cFunc2,cFunc3
	  already_exists = bakale+1
	endif
    bakale = bakale + 1
    endm
	
	;------------------------------------------------------------/
	
	
	if already_exists eq 0
		@CatStr(<@built_fa_>,%@global_done_actions) textequ cFunc
		@CatStr(<@built_fa2_>,%@global_done_actions) CATSTR cName,<_>,cFunc
		@global_done_actions = @global_done_actions + 1
	else
	 @CatStr(<@built_fa2_>,%(already_exists-1)) CATSTR cName,<_>,cFunc
	endif
	
	ifdifi cFunc,<__$delete>
		bakame CATSTR <_>, cFunc, <$r>  ;  CATSTR curClass,<_>,cFunc,<$r>
		baka CATSTR cName,<_>,cFunc
		@CatStr(%curClass,%bakame) textequ <&baka>
	endif
	
endm	
;=======/
;=====<< ENLIST CLASS ACTIONS >>===\
@enlist_class_actions MACRO cName
	local ParentClass,baka,cvfn,cvft,tName
	local baka2,already_exists,fn,ft,ft2
	ParentClass CATSTR cName,<_$Parent>
	
	ifdif ParentClass,<>
		@enlist_class_actions &ParentClass
	endif
	
	
	
	;-------< enlist virtuals >----------------------------------------\
	cvft CATSTR cName,<_$afn>
	cvfn equ cvft
	baka=0
    while baka LT cvfn ; for each virtual function in this class ...
	cvft CATSTR cName,<_$an_>
	cvft CATSTR cvft,%baka
	
	;--< ADD VIRTUAL FUNCTION !>------------\*********************************************************
	; cName - cur class
	; cvft  - func name
	
	@AddActionFunction cName,cvft
	
	;---------------------------------------/*********************************************************
	
	@global_actions_num=@global_actions_num +1
	baka=baka+1
    endm
	;------------------------------------------------------------------/
	
endm
;=======/
;=====<< NEW and DELETE >>===\
	
HeapFree proto :DWORD,:DWORD,:DWORD
HeapAlloc proto :DWORD,:DWORD,:DWORD
.data
HEAP1 dd 0
.code
malloc_func proc uses ebx ecx edx esi edi How
	.if !HEAP1
		invoke HeapCreate,0,10000,0
		mov HEAP1,eax
	.endif
	invoke HeapAlloc,HEAP1,HEAP_ZERO_MEMORY,How	
	ret
malloc_func endp
	
free_func proc uses eax ebx ecx edx esi edi What
	invoke HeapFree,HEAP1,0,What
	ret
free_func endp
	
malloc MACRO How:REQ
	invoke malloc_func,How
	exitm <eax>
ENDM
	
free MACRO What
	invoke free_func,What
ENDM
	
	
	
$new MACRO What:REQ,ClassName:REQ,var1:VARARG
	local baka4,vara
	push eax
	push ecx
	push edi
	xor eax,eax
	mov ecx,sizeof ClassName
	lea edi,What
	rep stosb
	pop edi
	pop ecx
	pop eax

; push ecx ;<-----
	lea ecx,What
	mov dword ptr[ecx],offset ClassName&_$virt_table
	baka4 textequ <ClassName&_$NewArgs>
	ifb baka4
		invoke @CatStr(ClassName,<___>,ClassName) ; call the constructor, returned pointer in eax
	else
		for vara,<var1>
			ifidni <vara>,<ecx>
			.err <Please do not use ECX as a parameter in "new">
			endif
		endm
		invoke @CatStr(ClassName,<___>,ClassName),var1
	endif
; pop ecx ;<-----
	;ecx and eax should have the pointer ;)
endm	
	
		
new MACRO ClassName:REQ,var1:VARARG
	local baka4,vara
	baka4 textequ <ClassName&_$NewArgs>
; push ecx
	xor ecx,ecx
	ifidn baka4,<>
		invoke @CatStr(ClassName,<___>,ClassName) ; call the constructor, returned pointer in eax
	else
		for vara,<var1>
			ifidni <vara>,<ecx>


			.err <Please do not use ECX as a parameter in "new">
			endif
		endm
		invoke @CatStr(ClassName,<___>,ClassName),var1
	endif
; pop ecx
	exitm <eax> ; ECX and EAX have it now
endm
		
delete MACRO What
	push eax
	push ecx
	mov ecx,What
	push 0
	call dword ptr[ecx]
	pop ecx
	pop eax
endm
	
DeleteCOM macro What:REQ,ClassName:REQ
	push eax
	push ecx
	ifdifi <ecx>,<What>
	mov ecx,What
	endif
	invoke @CatStr(ClassName,<___$delete>),0
	pop ecx
	pop eax
endm	
;=======/
	
;=====<< SET.macro >>===\
set macro zWhat:VARARG
	local char1,var1,WhatS,dType,lastWasSpace
	
	;----[ clean-up coding stuff ]----------\
	lastWasSpace = 0
	txt textequ <>
	forc char1,<zWhat>
	 ifidn <char1>,< >
		if lastWasSpace eq 0
			lastWasSpace = 1
			 txt CATSTR txt,<char1>
		endif
	 elseifidn <char1>,<	>
		if lastWasSpace eq 0
			lastWasSpace = 1
			 txt CATSTR txt,<char1>
		endif
	 else
		 txt CATSTR txt,<char1>
		lastWasSpace = 0
	 endif
	endm
	;--------------------------------------/
	lastWasSpace INSTR txt,< as >
	WhatS SUBSTR txt,1,lastWasSpace-1
	dType SUBSTR txt,lastWasSpace+4
	%for var1,<WhatS>
		@CatStr(<@rcd$>,<var1>) CATSTR dType
	endm	
	
endm	
;=======/
	
;=====<< pCall >>===\
pCall macro FuncNameX:REQ,var1:VARARG
	local FuncName,VariableNa,baka,baka2,thisClassType
	baka2 INSTR <FuncNameX>,<.>
	ife baka2
	    .err <Please use this syntax: pCall Variable.FunctionName[,arguments]>
	    exitm
	endif
	VariableNa SUBSTR <FuncNameX>,1,baka2-1
	FuncName SUBSTR <FuncNameX>,baka2+1
	thisClassType CATSTR <@rcd$>,VariableNa
	baka2 INSTR thisClassType,<@rcd$>
	if baka2 eq 1
	    thisClassType CATSTR <Please tell what class ">,VariableNa,<" is, using "set >,VariableNa,< as !<ClassName!>">
	    .err thisClassType
	    exitm
	endif
	
	
	%iCall VariableNa,thisClassType,FuncName,var1
endm		
;=======/
	
;=====<< nCall, oCall >>===\
	
Scall MACRO name:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22

    FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,\
             p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
      IFNB <arg>    ;; If not blank
        push arg    ;; push parameter
      ENDIF
    ENDM

    call name       ;; call the procedure

ENDM
ccall MACRO name:REQ,p1,p2,p3,p4,p5,p6,p7,p8,p9,p10,p11,p12,p13,p14,p15,p16,p17,p18,p19,p20,p21,p22
	local stas
	stas=0
    FOR arg,<p22,p21,p20,p19,p18,p17,p16,p15,p14,p13,\
             p12,p11,p10,p9,p8,p7,p6,p5,p4,p3,p2,p1>
      IFNB <arg>    ;; If not blank
        push arg    ;; push parameter
	stas = stas +4
      ENDIF
    ENDM

    call name       ;; call the procedure
	if stas ne 0
		add esp,stas
	endif
ENDM


nCall macro What:REQ,FuncName:REQ,var1:VARARG
	ifidn DefaultClassName,<>
	  .err <Please set some default class, using "SetDefClass">
	  exitm
	endif	
	%iCall What,DefaultClassName,FuncName,var1
endm	
	
oCall macro FuncName:REQ,var1:VARARG
	ifidn DefaultClassName,<>
	  .err <Please set some default class, using "SetDefClass">
	  exitm
	endif	
	%iCall ecx,DefaultClassName,FuncName,var1
endm	
	
	
static macro what:VARARG
	@CatStr(<@statics>,%@statics_num) textequ <what>
	;.err @CatStr(<@statics>,%@statics_num)
	@statics_num = @statics_num + 1
endm

	
icall textequ <iCall> ; recommended for beginners
ncall textequ <nCall> ; Default Call (Normal Call)
ocall textequ <oCall> ; save-coder-time call
pcall textequ <pCall>
iaction textequ <iAction>
void textequ <iAction>
		
SetDefClass macro What
	DefaultClassName textequ <What>
endm	
	

;=======/
;=====<< iCall MACRO >>===\
iCall macro What:REQ,ClassName:REQ,FuncName:REQ,var1:VARARG
	local argsNum,thisArgsNum,origFunc,cvft,errTxt1,txt,arg,FunctionID,IsVirtual,baka,EAX_overwritten,num1
	
	;-----[ Initial adjustments ]--------\
	if PreserveClassECX
		push ecx
	endif
	if AdjustClassStack
		ifndef esp2
			.err <Please create a local variable "esp2" in this procedure>
		endif
	  mov esp2,esp
	endif
	thisArgsNum=0
	FOR arg,<var1>
	 IFNB <arg>

		thisArgsNum = thisArgsNum + 1
	 ENDIF
	ENDM
	;------------------------------------/
	
	;------[ Is This Function Defined? Is it virtual? Check parameters, too ]-------------------------\
   ifdef ClassName&_&FuncName&$r
	origFunc CATSTR <ClassName>,<_>,<FuncName>,<$r>
	IsVirtual = @CatStr(%origFunc,<$isV>)
	argsNum = @CatStr(%origFunc,<$argz>)
	if argsNum ne 1000
		if argsNum ne thisArgsNum		
			errTxt1 CATSTR <Parameters number is not >,%argsNum,<, you've forgotten/added some>
			.err errTxt1
			exitm
		endif
	endif
   else	
	.err <Function ClassName&_&FuncName not defined!!>
	exitm
   endif
	;------------------------------------------------------------------------------------------------/
	
	
	;-------[ Push parameters ]------------\
	ifnb <var1>
	EAX_overwritten = 0
	txt TEXTEQU <>
	% FOR arg, <var1>
	      txt CATSTR <arg>, <!,>, txt
	ENDM
 	txt SUBSTR  txt, 1, @SizeStr( %txt ) - 1
   	txt CATSTR  <!<>, txt, <!>>
	% FOR arg,txt
	 IFNB <arg>
		ifidni <arg>,<eax>
			if EAX_overwritten
				.err <EAX has already been overwritten! Do not use EAX on the left of ADDR>
			endif
		endif
		
		
		num1 SIZESTR <arg>
		if num1 LT 6
			num1 = 0
		else
			num1 = 0
			ifidni @SubStr(<arg>,1,5),<addr >
				num1 = 1
			endif
		endif
		
		if num1
			EAX_overwritten = 1
			lea eax,@SubStr(<arg>,6)
			push eax
		else
			push arg
		endif
	 ENDIF
	ENDM
	endif
	;-------------------------------------/
	
	
	;-------------[ Call the function ]----------\
	ifdifi <ecx>,<What>
  	   mov ecx,What
	endif
	ife @CatStr(ClassName, <_$cpp>) ; if not C++ compatible
	  push ecx
	endif
	
	
	if IsVirtual
		FunctionID = ClassName&_&FuncName&$
		mov eax,[ecx]
		call dword ptr[eax+FunctionID*4]
	else
		call origFunc
	endif
	;-------------------------------------------/
	
	;--[ clean up ]----\
	if AdjustClassStack
	  mov esp,esp2
	endif
	if PreserveClassECX
		pop ecx
	endif
	;------------------/
endm 		
;=======/	
;=====<< EnterHostedClass >>===\
	; beware of inverse logic. 
	; Read "HostedClass" as 
	;     "Should the wrapper expect code for this class' functions"
EnterHostedClass macro
	HostedClass=0
endm
	
LeaveHostedClass macro
	HostedClass=1
endm
	
;=======/	
;=====<< DoWeSupportGUIDs >>===\
DoWeSupportGUIDs macro What:REQ,Which:VARARG
local _good,giia
for giia,<Which>
	mov ecx,What
	lea edx,giia
	mov eax,[ecx+0]
	sub eax,[edx+0]
	jnz @F
	mov eax,[ecx+4]
	sub eax,[edx+4]
	jnz @F
	mov eax,[ecx+8]
	sub eax,[edx+8]
	jnz @F
	mov eax,[ecx+12]
	sub eax,[edx+12]
	@@:
	jz _good
endm
	mov eax,E_NOINTERFACE
	jmp @F
  _good:
	mov eax,S_OK
    @@:	
endm	
;=======/
;=====<< STACKSAVER >>===\
		
CTEXT macro Text:VARARG
        local szText
        .data
        szText byte Text, 0
        .code
        exitm <offset szText>        
endm
	
.data?
	ThisStackSaver dd 128 dup (?)
.data
	ThisStackSaver_num dd 0
.code	
	
ThisStackBad proc whatPos,whatDif
	local str1[200]:byte
 ifdef wsprintfA
	invoke wsprintfA,addr str1,CTEXT("Stack corruption before EIP %Xh   , stack difference is %li "),whatPos,whatDif
	
	; having pushed too much leads to negative difference, showed above.
	
	invoke MessageBox,0,addr str1,CTEXT("Stack error!"),MB_ICONEXCLAMATION
	
 endif
	ret
ThisStackBad endp
	
	
startstack macro
	push eax
	push ecx
	mov eax,esp
	mov ecx,ThisStackSaver_num
	mov ThisStackSaver[ecx*4],eax
	inc ThisStackSaver_num
	pop ecx
	pop eax
endm	
	
endstack macro
	local goodies,heree
  heree:
	push eax ; same pushes as above
	push ecx
	
	mov eax,esp
	dec ThisStackSaver_num
	mov ecx,ThisStackSaver_num
	sub eax,ThisStackSaver[ecx*4]
	jz goodies 
	mov esp,ThisStackSaver[ecx*4]
	invoke ThisStackBad,heree,eax
  goodies:
	
	pop ecx
	pop eax
endm	
;=======/
	
	
action macro
	
endm
	
remalloc macro pmem:REQ, How:REQ
            push ecx
	invoke HeapReAlloc,HEAP1,HEAP_ZERO_MEMORY,pmem, How	
            pop ecx
            exitm <eax>
endm	